/*
 * Author : - KHODIDAS DOMADIYA\
 * Organization: - Optimzed Solutions Ltd.
 * Department: -Product ENgineering services.
 *
 * Date:- 12-05-2021

 *=> IP ADDRESS USED IS STATIC
 *

 *
 *
 * Indication OF leds - For ethernet , default LEDs used
 *
 *
 */


/*
 *    ======== tcpEcho.c ========
 */

/* XDCtools Header files */
#include <stdint.h>
#include <stdio.h>
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include <xdc/std.h>
#include <xdc/cfg/global.h>
#include <ti/sysbios/hal/Hwi.h>

#include <xdc/runtime/Error.h>
#include <xdc/runtime/Memory.h>
#include <xdc/runtime/System.h>

/* BIOS Header files */
#include <ti/sysbios/BIOS.h>
#include <ti/sysbios/knl/Clock.h>
#include <ti/sysbios/knl/Task.h>

 /* NDK Header files */
#include <ti/ndk/inc/netmain.h>
#include <ti/ndk/inc/_stack.h>

/* TI-RTOS Header files */
#include <ti/drivers/GPIO.h>

/* Example/Board Header files */
#include "Board.h"


//#include <time.h>
#include "inc/hw_memmap.h"
#include "inc/hw_types.h"
#include "inc/hw_sysctl.h"
#include "driverlib/sysctl.h"

#include "driverlib/pin_map.h"

#include "inc/hw_gpio.h"
#include "driverlib/gpio.h"

#include "inc/hw_ints.h"
#include "driverlib/interrupt.h"

#include "inc/hw_timer.h"
#include "driverlib/timer.h"



#include "inc/hw_flash.h"
#include "driverlib/flash.h"

//============================Ethernet ========================//

#define TCPPACKETSIZE 1024
#define TCPPORT 8080
#define NUMTCPWORKERS 3
#define BUF_SIZE 12412


char thbuffer[10];
SOCKET lSocket;
struct sockaddr_in sLocalAddr;
char  mydata[BUF_SIZE];


//============================================================//

//============================SYSTEM CLOCK========================//
uint32_t g_ui32SysClock;
//============================================================//

//============================================================//

int error;

char pin_data[208];
char rcvd_data[4];
bool TIMER_ON=0;

bool MASTER;
uint8_t SLAVE_ADDRESS;




void READ_GPIO(uint8_t j)
{
    pin_data[j] = GPIOPinRead(GPIO_PORTD_BASE, GPIO_PIN_0);
    pin_data[j] = GPIOPinRead(GPIO_PORTD_BASE, GPIO_PIN_4);
    pin_data[j] = GPIOPinRead(GPIO_PORTL_BASE, GPIO_PIN_7);
    pin_data[j] = GPIOPinRead(GPIO_PORTD_BASE, GPIO_PIN_7);
    pin_data[j] = GPIOPinRead(GPIO_PORTD_BASE, GPIO_PIN_4);
    pin_data[j] = GPIOPinRead(GPIO_PORTE_BASE, GPIO_PIN_4);
    pin_data[j] = GPIOPinRead(GPIO_PORTM_BASE, GPIO_PIN_4);
    pin_data[j] = GPIOPinRead(GPIO_PORTP_BASE, GPIO_PIN_3);
    pin_data[j] = GPIOPinRead(GPIO_PORTM_BASE, GPIO_PIN_2);
    pin_data[j] = GPIOPinRead(GPIO_PORTM_BASE, GPIO_PIN_3);
    pin_data[j] = GPIOPinRead(GPIO_PORTM_BASE, GPIO_PIN_7);
    pin_data[j] = GPIOPinRead(GPIO_PORTM_BASE, GPIO_PIN_0);
    pin_data[j] = GPIOPinRead(GPIO_PORTN_BASE, GPIO_PIN_0);
    pin_data[j] = GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_4);
    pin_data[j] = GPIOPinRead(GPIO_PORTP_BASE, GPIO_PIN_5);
    pin_data[j] = GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_2);
    pin_data[j] = GPIOPinRead(GPIO_PORTD_BASE, GPIO_PIN_6);
    pin_data[j] = GPIOPinRead(GPIO_PORTM_BASE, GPIO_PIN_1);
    pin_data[j] = GPIOPinRead(GPIO_PORTL_BASE, GPIO_PIN_6);
    pin_data[j] = GPIOPinRead(GPIO_PORTM_BASE, GPIO_PIN_6);
    pin_data[j] = GPIOPinRead(GPIO_PORTP_BASE, GPIO_PIN_4);
    pin_data[j] = GPIOPinRead(GPIO_PORTL_BASE, GPIO_PIN_0);
    pin_data[j] = GPIOPinRead(GPIO_PORTL_BASE, GPIO_PIN_3);
    pin_data[j] = GPIOPinRead(GPIO_PORTN_BASE, GPIO_PIN_1);
}

void MASTER_SLAVE()
{
    bool t1,t2,t3;
    t1=GPIOPinRead(GPIO_PORTD_BASE, GPIO_PIN_0);
    t2=GPIOPinRead(GPIO_PORTD_BASE, GPIO_PIN_1);
    t3=GPIOPinRead(GPIO_PORTD_BASE, GPIO_PIN_2);
    SLAVE_ADDRESS = (t1<<0) + (t2<<1) +(t3<<2);

    if(SLAVE_ADDRESS==0x00)
    {
        MASTER=1;
    }
    else
    {
        MASTER=0;
    }
}
void ModBus_SELCET(void)
{
    // Enable the GPIO Peripheral used by the MODBUS.
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOQ);


    // select GPIO for MODBUS address
     GPIOPinTypeGPIOInput(GPIO_PORTD_BASE, GPIO_PIN_0);
     GPIOPinTypeGPIOInput(GPIO_PORTD_BASE, GPIO_PIN_1);
     GPIOPinTypeGPIOInput(GPIO_PORTD_BASE, GPIO_PIN_2);
     GPIOPinTypeGPIOInput(GPIO_PORTD_BASE, GPIO_PIN_3);
     GPIOPinTypeGPIOInput(GPIO_PORTQ_BASE, GPIO_PIN_0);
}


void MUX_ADR_INIT()
{
    GPIOPinTypeGPIOOutput(GPIO_PORTK_BASE, GPIO_PIN_0);
    GPIOPinTypeGPIOOutput(GPIO_PORTK_BASE, GPIO_PIN_1);
    GPIOPinTypeGPIOOutput(GPIO_PORTK_BASE, GPIO_PIN_2);
}
//*****************************************************************************
//
// timer interrupt
//
//*****************************************************************************

void Timer0IntHandler(void)
{
    uint8_t  i;

    TimerIntClear(TIMER0_BASE, TIMER_TIMA_TIMEOUT);
    //TimerSynchronize(TIMER0_BASE, TIMER_TIMA_TIMEOUT);


        for(i=0;i<8;i++)
           {
                READ_GPIO(i);
           }




}

void adr_cntrl(uint8_t temp)
{
    GPIOPinWrite(GPIO_PORTK_BASE, GPIO_PIN_0,  temp);
    GPIOPinWrite(GPIO_PORTK_BASE, GPIO_PIN_1, temp);
    GPIOPinWrite(GPIO_PORTK_BASE, GPIO_PIN_2, temp);

}
void TimerStart(void)
{
  TimerEnable(TIMER0_BASE,TIMER_A);
}

//*****************************************************************************
//
//  timer run for 1msec
//
//*****************************************************************************

void TimerCon(void)
{
       //
       // Initialize the UART and write status.
       //
       SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER0);

       //
       // Enable processor interrupts.
       //
       IntMasterEnable();

       //
       // Configure periodic timers.
       //
       TimerConfigure(TIMER0_BASE, TIMER_CFG_PERIODIC);
       TimerLoadSet(TIMER0_BASE, TIMER_A, g_ui32SysClock/1000); // 1ms

       //
       // Setup the interrupts for the timer timeouts.
       //
       TimerIntRegister(TIMER0_BASE,TIMER_A,Timer0IntHandler);
       IntRegister(INT_TIMER0A,Timer0IntHandler);
       IntEnable(INT_TIMER0A);
       TimerIntEnable(TIMER0_BASE, TIMER_TIMA_TIMEOUT);
       IntMasterEnable();
       //
       // Enable the timers.
       //
//       TimerEnable(TIMER0_BASE, TIMER_A);
}

//
// Timer stop
//
void TimerStop(void)
{
  TimerDisable(TIMER0_BASE,TIMER_A);
}

void GPIO_IN_INIT()
{

    GPIOPinTypeGPIOInput(GPIO_PORTD_BASE, GPIO_PIN_0);
    GPIOPinTypeGPIOInput(GPIO_PORTD_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOInput(GPIO_PORTL_BASE, GPIO_PIN_7);
    GPIOPinTypeGPIOInput(GPIO_PORTD_BASE, GPIO_PIN_7);
    GPIOPinTypeGPIOInput(GPIO_PORTD_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOInput(GPIO_PORTE_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOInput(GPIO_PORTM_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOInput(GPIO_PORTP_BASE, GPIO_PIN_3);
    GPIOPinTypeGPIOInput(GPIO_PORTM_BASE, GPIO_PIN_2);
    GPIOPinTypeGPIOInput(GPIO_PORTM_BASE, GPIO_PIN_3);
    GPIOPinTypeGPIOInput(GPIO_PORTM_BASE, GPIO_PIN_7);
    GPIOPinTypeGPIOInput(GPIO_PORTM_BASE, GPIO_PIN_0);
    GPIOPinTypeGPIOInput(GPIO_PORTN_BASE, GPIO_PIN_0);
    GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOInput(GPIO_PORTP_BASE, GPIO_PIN_5);
    GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_2);
    GPIOPinTypeGPIOInput(GPIO_PORTD_BASE, GPIO_PIN_6);
    GPIOPinTypeGPIOInput(GPIO_PORTM_BASE, GPIO_PIN_1);
    GPIOPinTypeGPIOInput(GPIO_PORTL_BASE, GPIO_PIN_6);
    GPIOPinTypeGPIOInput(GPIO_PORTM_BASE, GPIO_PIN_6);
    GPIOPinTypeGPIOInput(GPIO_PORTP_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOInput(GPIO_PORTL_BASE, GPIO_PIN_0);
    GPIOPinTypeGPIOInput(GPIO_PORTL_BASE, GPIO_PIN_3);
    GPIOPinTypeGPIOInput(GPIO_PORTN_BASE, GPIO_PIN_1);


}




/*
 *  ======== tcpHandler ========
 *  Creates new Task to handle new TCP connections.
 */
Void tcpHandler(UArg arg0, UArg arg1)
{
    fdOpenSession(TaskSelf());

    lSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (lSocket < 0)
    {
       // System_printf("tcpHandler: socket failed\n");
        Task_exit();
        return;
    }

    memset((char *)&sLocalAddr, 0, sizeof(sLocalAddr));
    sLocalAddr.sin_family = AF_INET;
    sLocalAddr.sin_addr.s_addr = inet_addr("192.168.1.130");//htonl(INADDR_ANY);
    sLocalAddr.sin_port = htons(arg0);

    while(connect(lSocket, (struct sockaddr *)&sLocalAddr, sizeof(sLocalAddr)) < 0)
    {
        SysCtlDelay(400000);
    }


    while (true)
    {

    }
}

/*
 *  ======== main ========
 */
int main(void)
{
//    Task_Handle taskHandle;
//    Task_Params taskParams;
//    Error_Block eb;

    g_ui32SysClock = SysCtlClockFreqSet((SYSCTL_XTAL_25MHZ |SYSCTL_OSC_MAIN | SYSCTL_USE_PLL |SYSCTL_CFG_VCO_480), 120000000);

    /* Call board init functions */
    Board_initGeneral();

    Board_initGPIO();
    Board_initEMAC();

       GPIO_IN_INIT();
       TimerCon();
      // ConfigureUART0();
       ModBus_SELCET();
       MUX_ADR_INIT();
       MASTER_SLAVE();
    /* Start BIOS */
    BIOS_start();

    return (0);
}
